/////////////////////////////////////////////////////////
//  elfBbv[^[pgJE^  interrupt.c  //
//  2024/07/03  PIC18F1320  C18                        //
/////////////////////////////////////////////////////////

#include "global.h"

volatile uchar staflg;      //vZJntO
volatile uint ovfcnt;       //^C}[OI[o[t[
volatile uint ovfcntc;      //^C}[OI[o[t[񐔃Rs[
volatile uchar tmr0c;       //TMR0L̃Rs[


void timer0_init(void){
    T0CON = 0b11110010;     //T0 8bit PS1/8
    INTCON2bits.TMR0IP = 1; //荞ݗD惌xʂɂĂ
    INTCONbits.TMR0IE = 1;  //^C}[O荞݋
}

void timer1_init(void){
    T1CON = 0xb1;           //Timer1 16bit,ps1/8,enable
    TMR1H = 0;              //Timer1 clear
    TMR1L = 0;
    PIE1bits.TMR1IE = 0;    //Timer1 荞݋֎~

    CCP1CON = 0xb;          //Special Event
    CCPR1H = 0xf4;
    CCPR1L = 0x24;          //100mS
    IPR1bits.CCP1IP = 1;    //荞ݗD惌xʑɂĂ
    PIE1bits.CCP1IE = 1;    //bbo荞݋
    staflg = 0;
}

#pragma interrupt isr
#pragma code isrcode = 0x8  
void jump_isr(void){            //荞݊֐փWviO͉łǂj
    _asm
    goto isr
    _endasm
}

#pragma code
void isr(void){                 //荞݊֐iO͉łǂj
    if(INTCONbits.TMR0IF){      //^C}[O荞
        INTCONbits.TMR0IF = 0;
        ovfcnt++;
    }
    if (PIR1bits.CCP1IF){       //bboP荞ݗv
        PIR1bits.CCP1IF = 0;
        tmr0c = TMR0L;
        TMR0L = 0;
        ovfcntc = ovfcnt;
        ovfcnt =0;
        staflg = 1;
        INTCONbits.TMR0IF = 0;  //̃^C}[O荞݂LZ
    }
}
